/*Lesson 1.6 Demo  -Examining the Syntax of the CREATE TABLE Statement and Compare with a Sample */

/* This demo creates the CertData database, 
the Production schema within the CertData database, 
and the table Production.Products.
*/

USE master;
GO

--Delete the CertData database if it exists --
IF EXISTS(SELECT * from sys.databases WHERE name='CertData')
BEGIN
    DROP DATABASE CertData;
END
GO

--Create and Use the CertData database --

CREATE DATABASE CertData;
GO


USE CertData;
GO

--Create the Production schema in the CertData database --

CREATE SCHEMA Production AUTHORIZATION dbo;
GO

-->>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
--Create the table Products in the Production schema of the CertData database --
/*
CREATE TABLE 
    [ database_name . [ schema_name ] . | schema_name . ] table_name 
    [ AS FileTable ]
    ( { <column_definition> | <computed_column_definition> 
        | <column_set_definition> | [ <table_constraint> ] 
| [ <table_index> ] [ ,...n ] } )
    [ ON { partition_scheme_name ( partition_column_name ) | filegroup 
        | "default" } ] 
    [ { TEXTIMAGE_ON { filegroup | "default" } ] 
    [ FILESTREAM_ON { partition_scheme_name | filegroup 
        | "default" } ]
    [ WITH ( <table_option> [ ,...n ] ) ]
[ ; ]

*/

CREATE TABLE Production.Products
   (ProductID int NOT NULL,
    ProductName varchar(25) NOT NULL,
    Price money NULL,
    ProductDescription varchar(max) NULL);
GO

-->>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
-- Move Products table to the Sales schema -------------------------------

CREATE SCHEMA Sales;
GO

--Moves the Production.Products table to the Sales schema --
ALTER SCHEMA Sales TRANSFER Production.Products;
GO

--Moves the Sales.Products table back to the Production schema
ALTER SCHEMA Production TRANSFER Sales.Products;
GO

-->>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
--Cleanup, if desired------------------------------------------

DROP SCHEMA SALES;
GO

DROP TABLE Production.Products;
GO

USE master;
GO

--Delete the CertData database if it exists - and if desired--
IF EXISTS(SELECT * from sys.databases WHERE name='CertData')
BEGIN
    DROP DATABASE CertData;
END
