/* Lesson 10.4 Demo 2 - Use the UPDATE Statement with Constraints */

-->>>>>>>>>>UPDATE Single Value using WHERE>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
USE AdventureWorks2012;
GO

SELECT TOP (10) *
FROM HumanResources.Programmers
ORDER BY BusinessEntityID;
GO

UPDATE HumanResources.Programmers
	SET HireDate = GETDATE()
WHERE BusinessEntityID IN (11,12,17);
GO

SELECT TOP (10) *
FROM HumanResources.Programmers
ORDER BY HireDate DESC;
GO

-->>>>>>>>>>>>>>UPDATE with Variable>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
USE AdventureWorks2012;
GO

DECLARE @NewVacationHrs int = 10;
UPDATE HumanResources.Programmers
SET VacationHours += @NewVacationHrs
WHERE BusinessEntityID = 12;
GO

SELECT TOP (10) *
FROM HumanResources.Programmers
ORDER BY HireDate DESC;
GO

-->>>>>>>>>>>>>>>>>>UPDATE Based on Join>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
USE CertData
GO

IF OBJECT_ID('Sales.Vendors') IS NOT NULL DROP TABLE Sales.Vendors;
GO

CREATE TABLE Sales.Vendors
(
	VendorID INT NOT NULL,
	VendorName varchar(30) NOT NULL,
	OrderAmount money NULL	
);
GO

INSERT INTO Sales.Vendors (VendorID, VendorName, OrderAmount)
  VALUES (2, 'SQL Studios', NULL)
		,(3, 'Visual Studios', NULL)
		,(4, 'TV Studios', NULL)
		,(5, 'Movie Studios', NULL);
GO

IF OBJECT_ID('Sales.Orders') IS NOT NULL DROP TABLE Sales.Orders;
GO
CREATE TABLE Sales.Orders
(
	OrderID INT NOT NULL,
	VendorID INT NOT NULL,
	SalesAmount money NULL	
);
GO

INSERT INTO Sales.Orders (OrderID, VendorID, SalesAmount)
  VALUES (101, 5, 5500.00)
		,(102, 3, 3300.00)
		,(120, 2, 1100.00);
GO

SELECT *
FROM Sales.Vendors;
GO

SELECT *
FROM Sales.Orders;
GO

--UPDATE the Vendors OrderAmount with Orders SalesAmount-----------
UPDATE VEN
  SET VEN.OrderAmount = ORD.SalesAmount
  From Sales.Vendors VEN
  INNER JOIN Sales.Orders ORD
    ON VEN.VendorID = ORD.VendorID;
GO

SELECT *
FROM Sales.Vendors;
GO

SELECT *
FROM Sales.Orders;
GO

-->>>>>>>>>>>>>>>>>>>>UPDATE Using SUBQUERY>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
--UPDATE Using TOP with ORDER BY in Subquery statement
---Add 5 VacationHours to last two hires NOTE: += to add 5 hours to existing --
USE AdventureWorks2012;
GO

UPDATE HumanResources.Programmers
SET VacationHours +=  5
FROM (SELECT TOP 2 BusinessEntityID FROM HumanResources.Programmers
     ORDER BY HireDate DESC) AS th
WHERE HumanResources.Programmers.BusinessEntityID = th.BusinessEntityID;
GO

SELECT TOP (10) *
FROM HumanResources.Programmers
ORDER BY HireDate DESC;
GO

--UPDATE Using TOP with ORDER BY and Calculation-----------------------
---Delete those 5 VacationHours from the last two hires----------------
UPDATE HumanResources.Programmers
SET VacationHours -=  5
FROM (SELECT TOP 2 BusinessEntityID FROM HumanResources.Programmers
     ORDER BY HireDate DESC) AS th
WHERE HumanResources.Programmers.BusinessEntityID = th.BusinessEntityID;
GO

SELECT TOP (10) *
FROM HumanResources.Programmers
ORDER BY HireDate DESC;
GO
