/* Lesson 10.6 Demo 3 - Use the DELETE and TRUNCATE Statements */

USE AdventureWorks2012
GO

-->>>>>>>>>>>>>>>>>>DELETE>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
-->>>>DELETE USING A PREDICATE<<<<-------------------------------------------------

DELETE FROM HumanResources.Programmers
WHERE BusinessEntityID = 20;
GO

-->>>>DELETE USING JOINS OR SUBQUERIES<<<<-----------------------------------------
--Create and fill a new table Sales.NewSalesOrderDetail and then delete using JOIN
USE [AdventureWorks2012]
GO

IF OBJECT_ID('Sales.NewSalesOrderDetail', 'U') IS NOT NULL 
DROP TABLE Sales.NewSalesOrderDetail;
GO

SELECT 
	SalesOrderID
    ,CarrierTrackingNumber
    ,OrderQty
    ,ProductID
    ,SpecialOfferID
    ,UnitPrice
    ,UnitPriceDiscount
    ,rowguid
    ,ModifiedDate
 INTO Sales.NewSalesOrderDetail
 FROM Sales.SalesOrderDetail;
GO 

SELECT *
FROM Sales.NewSalesOrderDetail;
GO
           
DELETE FROM Sales.NewSalesOrderDetail
	FROM Sales.SalesOrderHeader AS SOH
	INNER JOIN Sales.NewSalesOrderDetail AS OD
	  ON SOH.SalesOrderID = OD.SalesOrderID
WHERE SalesOrderNumber = 'SO43659';
GO

SELECT *
FROM Sales.NewSalesOrderDetail;
GO

SELECT *
FROM Sales.NewSalesOrderDetail
WHERE SalesOrderID = 43659;
GO



-->>>>DELETE USING TABLE EXPRESSIONS<<<<--------------------------------------------
--Create a new table, HumanResources.Programmers2, insert data and then DELETE 50 first hires 
IF OBJECT_ID('HumanResources.Programmers2', 'U') IS NOT NULL 
DROP TABLE HumanResources.Programmers2;

--Use SELECT INTO TO CREATE AND FILL the Programmers table ---------
--with only programmers employed by company -------------------------
SELECT BusinessEntityID, loginID, JobTitle, HireDate, VacationHours
INTO HumanResources.Programmers2
FROM HumanResources.Employee
WHERE SalariedFlag = 0;
GO

----query table--------------
SELECT BusinessEntityID, loginID, JobTitle, HireDate, VacationHours
FROM HumanResources.Programmers2
ORDER BY HireDate;
GO
-----Use CTE to DELETE ROWS--------------------------------------------------------------
WITH FirstHires AS
(
	SELECT TOP(50) *
	FROM HumanResources.Programmers2
	ORDER BY HireDate
)
DELETE FROM FirstHires;
GO

----query table---------------
SELECT BusinessEntityID, loginID, JobTitle, HireDate, VacationHours
FROM HumanResources.Programmers2
ORDER BY HireDate;
GO


-->>>>>>>>>>>>>>>>>>>>>>>>>TRUNCATE>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
--Using TRUNCATE --Deletes ALL rows of data in the stated table----
--Create a new table, HumanResources.Programmers2, insert data and then TRUNCATE table 
IF OBJECT_ID('HumanResources.Programmers2', 'U') IS NOT NULL 
DROP TABLE HumanResources.Programmers2;

--Use SELECT INTO TO CREATE AND FILL the Programmers table ---------
--with only programmers employed by company -------------------------
SELECT BusinessEntityID, loginID, JobTitle, HireDate, VacationHours
INTO HumanResources.Programmers2
FROM HumanResources.Employee
WHERE SalariedFlag = 0;
GO
-- query the table
SELECT BusinessEntityID, loginID, JobTitle, HireDate, VacationHours
FROM HumanResources.Programmers2;

TRUNCATE TABLE HumanResources.Programmers2;
GO

SELECT BusinessEntityID, loginID, JobTitle, HireDate, VacationHours
FROM HumanResources.Programmers2; 