/* Lesson 12.5 Demo 2 - Use IF-ELSE, WHILE, WAITFOR, GOTO, and RETURN Statements to Control the Procedure Flow */
-->>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
---A CASE construct is added in here - just for good measure-----------------------------------------------------

-->>>>Using CASE to Control Procedure Flow<<<<-----------------------------
USE AdventureWorks2012;
GO

SELECT * 
 FROM HumanResources.Programmers
 WHERE JobTitle LIKE N'%Manager'
 GO

IF OBJECT_ID ( 'HumanResources.uspUpdate_ProgVacationHours', 'P' ) IS NOT NULL 
    DROP PROCEDURE HumanResources.uspUpdate_ProgVacationHours;
GO
CREATE PROCEDURE HumanResources.uspUpdate_ProgVacationHours
  @NewHours smallint
  AS 
  SET NOCOUNT ON;
  UPDATE HumanResources.Programmers
  SET VacationHours = 
      ( CASE
           WHEN JobTitle LIKE N'%Manager' THEN VacationHours + @NewHours
           ELSE VacationHours
         END
      )
 GO
  
 EXEC HumanResources.uspUpdate_ProgVacationHours @NewHours = 5;
 GO
 
 SELECT * 
 FROM HumanResources.Programmers
 WHERE JobTitle LIKE N'%Manager'
 GO
  ---------------------------------------------------------------------
-->>>>>>Using WHILE to Control Procedure Flow<<<<<<--------------------

USE AdventureWorks2012;
GO


IF OBJECT_ID ( 'Production.uspProdCategoryList', 'P' ) IS NOT NULL 
    DROP PROCEDURE Production.uspProdCategoryList;
GO
--Variable @CatName is reassigned in the WHILE loop until the Category Names are exhausted
CREATE PROCEDURE Production.uspProdCategoryList
  @CatName nvarchar(50)
  AS 
  SET NOCOUNT ON;
  SET @CatName = (SELECT MIN(Name) FROM Production.ProductCategory);
  WHILE @CatName IS NOT NULL
	BEGIN
		Print @CatName;
		SET @CatName = (SELECT MIN(Name) FROM Production.ProductCategory 
			WHERE Name > @CatName);
	END;
GO

-->>The value of the INPUT Parameter does not matter since it is reset in the Proc<<---
EXEC Production.uspProdCategoryList @CatName =N'WHATEVER';
GO

-->>>>>>Using IF-ELSE to control flow - and also WAITFOR<<<<<<--------------------------		
USE AdventureWorks2012;
GO

IF OBJECT_ID('dbo.uspDelayExecute','P') IS NOT NULL
    DROP PROCEDURE dbo.uspDelayExecute;
GO

CREATE PROCEDURE dbo.uspDelayExecute 
   @DelayLength char(8)= '00:00:00' --hr:min:sec  
AS
DECLARE @DelayInfo varchar(255)
IF ISDATE('2000-01-01 ' + @DelayLength + '.000') = 0
    BEGIN
        SELECT @DelayInfo = 'Invalid time ' + @DelayLength 
        + ',hh:mm:ss, entered';
        PRINT @DelayInfo 
        RETURN(1)
    END
ELSE 
	BEGIN
    WAITFOR DELAY @DelayLength
    SELECT @DelayInfo = 'A total time of ' + @DelayLength + ', 
        hh:mm:ss, has elapsed! You are out of time. Please start over.'
    PRINT @DelayInfo;
END;
GO

/* This statement executes the dbo.uspDelayExecute procedure. */
EXEC dbo.uspDelayExecute  '30:00:00';
GO

EXEC dbo.uspDelayExecute  '00:00:10';
GO
