/* Lesson 13 Work with Functions - INLINE Code */

-->>>>>>Lesson 13.1>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
-->>>>Deterministic Built-in Function<<<<-----------------------------
USE AdventureWorks2012;
GO

SELECT SalesOrderID, SUM(OrderQty) AS 'Order Total'
FROM Sales.SalesOrderDetail
GROUP BY SalesOrderID;
GO

-->>>>Nondeterministic Built-in Function<<<<-----------------------------
-- Create local variable with DECLARE/SET syntax; using NEWID() function
--  Run the code more than once to show nondeterminism of NEW()-------------------

DECLARE @testid uniqueidentifier, @testcount INT
SET @testcount = 1

WHILE @testcount<= 5
	BEGIN
		SET @testid = NEWID()
		PRINT 'Value of the testid is: '+ CONVERT(varchar(255), @testid);
		SET @testcount +=1
	END;
GO

-->>>>>>Lesson 13.2>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
-->>>>Applying Built-In Scalar Function CHOOSE<<<<-----------------------

USE AdventureWorks2012;
GO

SELECT ProductCategoryID, Name
FROM Production.ProductCategory;
GO
----------------

SELECT ProductCategoryID
 ,CHOOSE (ProductCategoryID, 'Bikes','Components','Clothing','Accessories') AS 'Current Product Line'
FROM Production.ProductCategory;
GO

---------------
SELECT ProductCategoryID, CHOOSE (ProductCategoryID, 'Bikes','Components','Clothing','Accessories') AS 'Current Product Line', Name
FROM Production.ProductSubcategory;

-->>>>Applying Built-In Scalar Function IIF<<<<--------------------------

USE AdventureWorks2012;
GO

SELECT SalesOrderID
	,OrderQty AS 'Order Quantity'
	,IIF(OrderQty >= 40, 'Large Order', 'Small Order') AS 'Order Size'
FROM Sales.SalesOrderDetail
ORDER BY OrderQty DESC;
GO
