/* Lesson 13.5 Demo 2 - Implement Scalar and Table-Valued UDFs */
/* Basic format of a Multi-Statement Table-Valued User Defined Function*/
/*
CREATE FUNCTION dbo.ufnTableValuedUDF
(
     @FirstParam INT
    ,@SecondParam INT
)
RETURNS TABLE
AS
RETURN
(
    SELECT  @FirstParam AS col1
	       ,@SecondParam AS col2
);

*/

USE AdventureWorks2012;
GO

-->>>>CREATE and Implement Table-Valued UDF<<<<---------------------------
IF OBJECT_ID (N'dbo.ufnGetFilteredOrders', N'FN') IS NOT NULL
    DROP FUNCTION dbo.ufnGetFilteredOrders;
GO

CREATE FUNCTION dbo.ufnGetFilteredOrders
(
  @bottomamt AS MONEY,
  @topamt AS MONEY
 )
RETURNS @returntable TABLE 
(
	SalesOrderID  INT
	,CustomerID INT
	,SubTotal  MONEY
)
AS
BEGIN
  INSERT @returntable
	SELECT SalesOrderID, CustomerID, SubTotal
	FROM Sales.SalesOrderHeader
	WHERE SubTotal BETWEEN @bottomamt AND @topamt
  RETURN
END;
GO

-->>>>Implementing the Table-Valued Function<<<<--------------------
SELECT SalesOrderID, CustomerID, FORMAT(SubTotal,'N', 'en-us') AS 'Sales Order Amount'
FROM dbo.ufnGetFilteredOrders (100000.00,200000.00);






