/* Lesson 14 Optimize Queries - INLINE code */
------------------------------------------------------------------------
--INCLUDE ACTUAL EXECUTION PLAN CTRL-M----------------------------------
------------------------------------------------------------------------
-->>>>>>Lesson 14.2 Read and Analyze Query Plans<<<<<<---------
-->>>>>>Use a JOIN with a GROUP BY<<<<<<---------------------------------
USE AdventureWorks2012;
GO
 SELECT
    p.Name,
    Total = SUM(inv.Quantity)
FROM 
    Production.Product AS p
    JOIN Production.ProductInventory AS inv
    ON inv.ProductID = p.ProductID
	WHERE
    p.Name LIKE N'[A-E]%'
GROUP BY p.Name;
GO
-----------------------------------------------------------------------------
-->>>>>>Add ORDER BY to Query to see the difference in the execution plan<<<<<<
USE AdventureWorks2012;
GO

SELECT
    p.Name,
    Total = SUM(inv.Quantity)
FROM 
    Production.Product AS p
    JOIN Production.ProductInventory AS inv
    ON inv.ProductID = p.ProductID
	WHERE
    p.Name LIKE N'[A-E]%'
GROUP BY p.Name
ORDER BY p.Name;

-------------------------------------------------------------------------------
-->>>>>>Lesson 14.3 Understand Statistics<<<<<<--------------------------------
USE AdventureWorks2012;
 GO
 ---Show Statistics on Non-clustered index on Product_Name----------------------
 DBCC SHOW_STATISTICS ("Production.Product", AK_Product_Name );
 GO


-------------------------------------------------------------------------------
USE AdventureWorks2012;
 GO

SET STATISTICS TIME ON;
GO
SELECT ProductID, Name, DaysToManufacture
  FROM Production.Product
GO
SET STATISTICS TIME OFF;
GO

SET STATISTICS IO ON;
GO
SELECT ProductID, Name, DaysToManufacture
  FROM Production.Product
GO
SET STATISTICS IO OFF;
GO

-->>>>Checking Auto-Created statistics onthe Production Products table<<<<--
USE AdventureWorks2012;
GO

SELECT OBJECT_NAME(object_id) AS object_name
		,name AS statistics_name
		,auto_created 
	FROM sys.stats
WHERE object_id = OBJECT_ID(N'Production.Product', N'U');
GO

-->>>>Check Auto Statistics settings for databases<<<<----
use master;
GO

 SELECT name AS 'Name', 
     is_auto_create_stats_on AS "Auto Create Stats",
     is_auto_update_stats_on AS "Auto Update Stats",
     is_auto_update_stats_async_on AS "Auto Update Stats Async" 
 FROM sys.databases
 WHERE database_ID > 4;
 GO


