/* Lesson 15.3 Demo 1 - Control Transactions Using Transaction Commands */

-->>>>>>>>>>Using a Named Transaction with ROLLBACK

-->>>>Create a table in tempdb<<<<-----------------
USE tempdb;
GO
CREATE TABLE TranTable (col1 int);
GO

DECLARE @TranName varchar(20) = 'TranTest';
SELECT @@TRANCOUNT AS 'TRANCOUNT';
-->>Start a named transaction,
-->>insert two rows
-->>then roll back the transaction
BEGIN TRAN @TranName
       INSERT INTO TranTable VALUES(10), (20);
	   SELECT @@TRANCOUNT AS 'TRANCOUNT';
ROLLBACK TRAN @TranName;
SELECT @@TRANCOUNT AS 'TRANCOUNT';
-->>>>Insert two rows outside the transaction<<<<-------
INSERT INTO TranTable VALUES(30),(40);
SELECT @@TRANCOUNT AS 'TRANCOUNT';
-->>>>Result set only contains the last two rows entered outside the transaction<<<<--
SELECT col1 FROM TranTable;

-->>>>Delete table<<<<--
DROP TABLE TranTable;

-->>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
-->>>>Using Nested Transactions with ROLLBACK and @@TRANCOUNT--
-->>>>>>NOTE: Only one ROLLBACK Needed<<<<<<-------------------
USE tempdb;
GO
CREATE TABLE TranTable (col1 int);
GO

DECLARE @TranName varchar(20) = 'TranTest';
SELECT @@TRANCOUNT AS 'TRANCOUNT';
-->>Start a named transaction,
-->>insert two rows
-->>then roll back the transaction
BEGIN TRAN @TranName
	SELECT @@TRANCOUNT AS 'TRANCOUNT';
	BEGIN TRAN;
       INSERT INTO TranTable VALUES(10), (20);
	   SELECT @@TRANCOUNT AS 'TRANCOUNT';
ROLLBACK TRAN @TranName;
SELECT @@TRANCOUNT AS 'TRANCOUNT';

-->>>>Insert two rows outside the transaction<<<<-------
INSERT INTO TranTable VALUES(30),(40);
SELECT @@TRANCOUNT AS 'TRANCOUNT';

-->>>>Result set only contains the last two rows entered outside the transaction<<<<--
SELECT col1 FROM TranTable;

-->>>>Delete table<<<<--
DROP TABLE TranTable;