/* Lesson 15.6 Demo 2 - Work with Locking Protocola and Transaction Isolation Levels */

-->>>>>>Transaction Isolation Level set for the session<<<<<<-----------
--Shared locks held until the end of the session------------------------
USE AdventureWorks2012;
GO
SET TRANSACTION ISOLATION LEVEL REPEATABLE READ;
GO
BEGIN TRANSACTION;
GO
SELECT * 
    FROM HumanResources.EmployeePayHistory;
GO
--Check Isolation Mode ------------------------------------------
--3 = S (Shared). The holding session is granted shared access to the resource
SELECT rsc_type, req_mode AS 'Transaction Isolation Mode'
FROM sys.syslockinfo;
GO 
----Continue with transaction----------------------------------------
SELECT * 
    FROM HumanResources.Department;
GO
COMMIT TRANSACTION;
GO
SELECT rsc_type, req_mode AS 'Transaction Isolation Mode'
FROM sys.syslockinfo;
GO

-->>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
--->>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
-->>>>>>Transaction Isolation Level set for the session<<<<<<-----------
--Next Change the Isolation Level to Serializable-----------------------
USE AdventureWorks2012;
GO
SET TRANSACTION ISOLATION LEVEL SERIALIZABLE;
GO
BEGIN TRANSACTION;
GO
SELECT * 
    FROM HumanResources.EmployeePayHistory;
GO
--Check Isolation Mode ------------------------------------------
--13 = RangeS_S (Shared Key-Range and Shared Resource lock). Indicates serializable range scan.
SELECT rsc_type, req_mode AS 'Transaction Isolation Mode'
FROM sys.syslockinfo;
GO 
----Continue with transaction----------------------------------------
SELECT * 
    FROM HumanResources.Department;
GO
COMMIT TRANSACTION;
GO
-->>>>>>>>>>>Check After Commit<<<<<<___________________
--Check Isolation Mode ------------------------------------------
--3 = S (Shared). The holding session is granted shared access to the resource (Default)
SELECT rsc_type, req_mode AS 'Transaction Isolation Mode'
FROM sys.syslockinfo;
GO