/* Lesson 16 Evaluate Row-Based vs. Set-Based INLINE code */



-->>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
-->>>>>>Lesson 16.3 Built-In Cursor Functions<<<<<<--------------------
USE AdventureWorks2012;
GO

DECLARE Department_Cursor CURSOR
 FOR
 SELECT DepartmentID, Name
 FROM AdventureWorks2012.HumanResources.Department;
 OPEN Department_Cursor;
 FETCH NEXT FROM Department_Cursor;
WHILE @@FETCH_STATUS = 0 --FETCH SUCCESSFUL
   BEGIN
      FETCH NEXT FROM Department_Cursor;
   END;
 CLOSE Department_Cursor;
DEALLOCATE Department_Cursor;
GO

-->>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
-->>>>>>Lesson 16.5 Implement Row-Based Operations Without Cursors<<<<<<-
USE AdventureWorks2012;
GO

IF OBJECT_ID('HumanResources.uspGetEmployee') IS NOT NULL
  DROP PROC HumanResources.uspGetEmployee;
GO

CREATE PROC HumanResources.uspGetEmployee
(
  @empid AS INT
)
AS
	PRINT 'Getting Business Entity ' + CAST(@empid AS VARCHAR(10));
GO


USE AdventureWorks2012;
GO

SET NOCOUNT ON;

DECLARE @Iteratorid AS INT;
SET @Iteratorid = (SELECT TOP (1) BusinessEntityID
                  FROM HumanResources.Employee
                  ORDER BY BusinessEntityID);
WHILE @Iteratorid IS NOT NULL
BEGIN
  EXEC HumanResources.uspGetEmployee @empid = @Iteratorid;
  
  SET @Iteratorid = (SELECT TOP (1) BusinessEntityID
					FROM HumanResources.Employee
					WHERE BusinessEntityID > @Iteratorid --<<<<<SELECTS NEXT
					ORDER BY BusinessEntityID);
END;
GO

IF OBJECT_ID('HumanResources.uspGetEmployee') IS NOT NULL
  DROP PROC HumanResources.uspGetEmployee;
GO