/* 17.2: Demo - Using Try and Catch Blocks */

-->>>>>>This first example produces no error, ReorderPoint is printed, 
-->>>>>>TRY block completes, and control transferred past the CATCH block

USE AdventureWorks2012;
GO

BEGIN TRY
    UPDATE Production.Product
	SET ReorderPoint = ReorderPoint/1
		WHERE ProductID = 1;
	SELECT ReorderPoint
	FROM Production.Product
		WHERE ProductID = 1;
	PRINT 'Completing TRY block';
END TRY
BEGIN CATCH
	PRINT 'No can do';
END CATCH;
PRINT 'Continue after END CATCH';
GO

-->>>>>>This second example produces an error - division by zero
-->>>>>>TRY block does not complete, and control transferred to the CATCH block
-->>>>>>NOTE: We do not know the error or its description
USE AdventureWorks2012;
GO

BEGIN TRY
    UPDATE Production.Product
	SET ReorderPoint = ReorderPoint/0
		WHERE ProductID = 1;
	SELECT ReorderPoint
	FROM Production.Product
		WHERE ProductID = 1;
	PRINT 'Completing TRY block';
END TRY
BEGIN CATCH
	PRINT 'No can do';
END CATCH;
PRINT 'Continue after END CATCH';
GO