/* Lesson 2.6 Demo 2  Alter a View Using ORDER BY */

USE AdventureWorks2012 ;
GO

IF OBJECT_ID (N'HumanResources.vEmployeeHireDate', N'V') IS NOT NULL
	DROP VIEW HumanResources.vEmployeeHireDate;
GO

--Create View must be first in Batch -----------------------------
CREATE VIEW HumanResources.vEmployeeHireDate
	WITH SCHEMABINDING
AS
SELECT p.FirstName, p.LastName, emp.HireDate
	FROM HumanResources.Employee AS emp
		 JOIN Person.Person AS  p
	ON emp.BusinessEntityID = p.BusinessEntityID ;
GO

ALTER VIEW HumanResources.vEmployeeHireDate
	WITH SCHEMABINDING
AS
SELECT p.FirstName, p.LastName, emp.HireDate
	FROM HumanResources.Employee AS emp
		JOIN Person.Person AS  p
	ON emp.BusinessEntityID = p.BusinessEntityID
WHERE HireDate < CONVERT(DATETIME,'20030101',101) ;
GO
  
SELECT *
	FROM HumanResources.vEmployeeHireDate;
GO

----ALTER VIEW with invalid ORDER BY---------
ALTER VIEW HumanResources.vEmployeeHireDate
	WITH SCHEMABINDING
AS
SELECT p.FirstName, p.LastName, emp.HireDate
	FROM HumanResources.Employee AS emp
		JOIN Person.Person AS  p
	ON emp.BusinessEntityID = p.BusinessEntityID
ORDER BY p.LastName;
GO

----ALTER VIEW with valid ORDER BY including TOP---------
ALTER VIEW HumanResources.vEmployeeHireDate
	WITH SCHEMABINDING
AS
SELECT TOP 10 p.FirstName, p.LastName, emp.HireDate
	FROM HumanResources.Employee AS emp
		JOIN Person.Person AS  p
	ON emp.BusinessEntityID = p.BusinessEntityID
ORDER BY p.LastName;
GO

SELECT LastName, FirstName, HireDate
	FROM HumanResources.vEmployeeHireDate;
GO


-------------Delete the View------------------
	DROP VIEW HumanResources.vEmployeeHireDate;
GO

