/*--Lesson 2.7 Demo 3  Update a Table Using a View --*/
/*
These examples change the Department name and 
the values in the StartDate and EndDate columns
for an employee by referencing columns in the 
view HumanResources.vEmployeeDepartmentHistory. 

The view returns values from two tables , however, 
the updates succeed because the columns being modified 
are from only one of the base tables.
*/

USE AdventureWorks2012 ; 
GO

SELECT LastName, FirstName, Department, GroupName, StartDate, EndDate
	FROM HumanResources.vEmployeeDepartmentHistory;
GO

UPDATE HumanResources.vEmployeeDepartmentHistory
SET Department = 'New Product Design' 
WHERE LastName = N'Duffy' AND FirstName = N'Terri'; 
GO

SELECT LastName, FirstName, Department, GroupName, StartDate, EndDate
	FROM HumanResources.vEmployeeDepartmentHistory
WHERE LastName = N'Duffy' AND FirstName = N'Terri';
GO 

UPDATE HumanResources.vEmployeeDepartmentHistory
SET StartDate = '20140401', EndDate = GETDATE() 
WHERE LastName = N'Duffy' AND FirstName = N'Terri'; 
GO


-->>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>---
--Now let's check out the tables themselves for the updates-------
--Querying the underlying Tables for the Updates------------------

SELECT 
     p.[LastName] 
    ,p.[FirstName] 
    ,d.[Name] AS [Department] 
    ,edh.[StartDate] 
    ,edh.[EndDate]
FROM [HumanResources].[Employee] e
	INNER JOIN [Person].[Person] p
	ON p.[BusinessEntityID] = e.[BusinessEntityID]
    INNER JOIN [HumanResources].[EmployeeDepartmentHistory] edh 
    ON e.[BusinessEntityID] = edh.[BusinessEntityID] 
    INNER JOIN [HumanResources].[Department] d 
    ON edh.[DepartmentID] = d.[DepartmentID] 
    INNER JOIN [HumanResources].[Shift] s
    ON s.[ShiftID] = edh.[ShiftID]
WHERE LastName = 'Duffy';

GO

