/*Lesson 3.2 Demo  - Define a Primary Key Constraint Using CREATE Table and ALTER Table */

-->>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>--
--If you already have created the CertData database, proceed to the next section---------- 
/* This section of code creates the CertData database and 
the Production schema within the CertData database 


USE master;
GO

--Delete the CertData database if it exists --
IF EXISTS(SELECT * from sys.databases WHERE name='CertData')
BEGIN
    DROP DATABASE CertData;
END
GO

--Create and Use the CertData database --

CREATE DATABASE CertData;
GO


USE CertData;
GO

--Create the Production schema in the CertData database --

CREATE SCHEMA Production AUTHORIZATION dbo;
GO

-->>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>--
--If Production.Products already exists in CertData, drop it --------------------
IF EXISTS ( SELECT [name] FROM sys.tables WHERE [name] = 'Production.Products' )
DROP TABLE Production.Products;
GO

-->>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>--
--Create the table Products in the Production schema of the CertData database ----
--Define PRIMARY KEY Constraint on ProductID while creating the table---------- --
CREATE TABLE Production.Products
   (ProductID int  NOT NULL,
    ProductName varchar(50) NOT NULL,
    Price money NULL,
    ProductDescription varchar(max) NULL
	CONSTRAINT PK_Products_ProductID PRIMARY KEY(ProductID)
	);
GO
*/
-->>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>--
--If Production.Products already exists in CertData, drop it --------------------
/*IF EXISTS ( SELECT [name] FROM sys.tables WHERE [name] = 'Production.Products' )
DROP TABLE Production.Products
GO

--Create the table Products in the Production schema of the CertData database --
--Define PRIMARY KEY Constraint on ProductID using ALTER TABLE --
CREATE TABLE Production.Products
   (ProductID int  NOT NULL,
    ProductName varchar(50) NOT NULL,
    Price money NULL,
    ProductDescription varchar(max) NULL
	);
GO
*/
ALTER TABLE Production.Products
 ADD CONSTRAINT PK_Products_ProductID PRIMARY KEY(ProductID);
GO

-->>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>--
--Lesson 3.7 Uses the Production.Products table, 
--so if you are going through all lessons - you might not want to drop the table
--Delete the Primary Key Constraint -------------------------------
ALTER TABLE Production.Products
 DROP CONSTRAINT PK_Products_ProductID;
GO

--Delete the table-------------------------------------------------
DROP TABLE Production.Products;
GO


USE master;
GO

--Delete the CertData database if desired-------------------------
IF EXISTS(SELECT * from sys.databases WHERE name='CertData')
BEGIN
    DROP DATABASE CertData;
END