/*Lesson 3.7 Demo  - Work with Constraints to Enforce Data Integrity   */

/* 
Uncomment the following code block to 
create the CertData database, 
the Production schema within the CertData database, 
and the table Production.Products with Primary Key constraint
and Unique constraint
*/

/*>>>>>>>>>>>>>>>>>>BEGIN CODE BLOCK>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
USE master;
GO

--Delete the CertData database if it exists --
IF EXISTS(SELECT * from sys.databases WHERE name='CertData')
BEGIN
    DROP DATABASE CertData;
END
GO

--Create and Use the CertData database --

CREATE DATABASE CertData;
GO


USE CertData;
GO

--Create the Production schema in the CertData database --

CREATE SCHEMA Production AUTHORIZATION dbo;
GO


--Create the table Products in the Production schema of the CertData database --
--Define PRIMARY KEY Constraint on ProductID --
CREATE TABLE Production.Products
   (ProductID INT  NOT NULL,
    ProductName varchar(50) NOT NULL,
	CategoryID INT NOT NULL,
    Price money NULL,
    ProductDescription varchar(max) NULL
	CONSTRAINT PK_Products_ProductID PRIMARY KEY(ProductID),
	CONSTRAINT UQ_Products_ProductName UNIQUE(ProductName)
	);
GO
*/
-->>>>>>>>>>>>>>>>>>>>>END CODE BLOCK>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>

/*
--Create Production.Categories table --
CREATE TABLE Production.Categories(
	CategoryID INT IDENTITY(1,1) NOT NULL,
	CategoryName NVARCHAR (40),
	Description NVARCHAR(max)
	CONSTRAINT PK_Categories_CategoryID PRIMARY KEY(CategoryID),
);
GO

--INSERT VALUES INTO PRODUCTS TABLE --
INSERT INTO Production.Products
	VALUES (461,'Querying Microsoft SQL Server 2012', 1, 150.00, 'Create Databae Objects; Work with Data; Modify Data; Troubleshoot and Optimize'),
	(462,'Administering Microsoft SQL Server 2012  Databases', 1, 150.00,'Install and Configure; Maintain Instances and Databases; Optimize and Troubleshoot'),
	(463,'Implementing a Data Warehouse with SQL Server 2012', 1,  150.00,'Design and Implement Data Warehouse; Extract and Transform Data'),
	(464,'Developing Microsoft SQL Server Databases',2, 150.00,'Implement Database Objects; Implement Programming Objects'),
	(465,'Designing Database Solutions', 2, 150.00,'Design a Database Structure; Design Databases and Database Objects'),
	(466, 'Implementing Data Models and Reports', 3, 150.00, 'Build an analysis services multidimensional database'),
	(467, 'Designing Business Intelligence Solutions', 3, 150.00, 'Plan business intelligence infrastructure'); 
GO   


--INSERT VALUES INTO CATEGORIES TABLE --
INSERT INTO Production.Categories (categoryname ,description)
	VALUES(N'MCSA SQL Server 2012', N'Microsoft Solutions Associate'),
	(N'MCSE Data Platform', N'Microsoft Certified Solutions Expert'),
	(N'MCSE Business Intelligence', N'Microsoft Certified Solutions Expert');
GO
*/
------------------------------------------------------------------------------------
--Create FOREIGN KEY on Production.Products ----------------------------------------
ALTER TABLE Production.Products WITH CHECK
	ADD CONSTRAINT FK_Products_Categories FOREIGN KEY(CategoryID)
	REFERENCES Production.Categories (CategoryID);
GO

-------------------------------------------------------------------------------------
--Create CHECK constraint on Production.Products ------------------------------------
ALTER TABLE Production.Products WITH CHECK
	ADD CONSTRAINT CHK_Products_Price
	CHECK (Price>=0);
GO

--INSERT a negative Price which conflicts with CHECK constraint---------------------------------
--Error message: The INSERT statement conflicted with the CHECK constraint "CHK_Products_Price"-
INSERT INTO Production.Products
	VALUES(500,'PowerShell for Fun',-40.00,'We pay you to Learn PowerShell',1);
GO

-->>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
-- Create a JOIN of the Products and Categories tables------------------------------
--Using the key references----------------------------------------------------------
USE CertData
GO

SELECT P.ProductName, C.CategoryName
 FROM Production.Products AS P
	JOIN Production.Categories AS C
		ON P.CategoryID = C.CategoryID
GO  


-->>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
--DELETE THE CERTDATA DATABASE IF DESIRED ------------------------------------------
USE master;
GO

--Delete the CertData database if it exists.
IF EXISTS(SELECT * from sys.databases WHERE name='CertData')
BEGIN
    DROP DATABASE CertData;
END
