/* LESSON 5.12 Demo 4 - Use Joins to Access Data */

USE CertData
GO

--INSERT a new row into the Production.Categories table --
INSERT INTO Production.Categories
VALUES(N'New Cert Name', N'New Description');
GO

--INNER JOIN--
SELECT C.CategoryName, P.ProductID, P.ProductName
FROM Production.Products AS P
JOIN Production.Categories AS C
on P.CategoryID = C.CategoryID 
ORDER BY C.CategoryName, P.ProductID;
GO

--CROSS JOIN--
SELECT C.CategoryName, P.ProductID, P.ProductName
FROM Production.Products AS P
CROSS JOIN Production.Categories AS C
ORDER BY C.CategoryName, P.ProductID;
GO

--LEFT OUTER JOIN with PRODUCTS table on the LEFT (first named) --
SELECT C.CategoryName, P.ProductID, P.ProductName
FROM Production.Products AS P
LEFT OUTER JOIN Production.Categories AS C
on P.CategoryID = C.CategoryID 
ORDER BY C.CategoryName, P.ProductID;
GO

--RIGHT OUTER JOIN with PRODUCTS table on LEFT (first named) --
SELECT C.CategoryName, P.ProductID, P.ProductName
FROM Production.Products AS P
RIGHT OUTER JOIN Production.Categories AS C
on P.CategoryID = C.CategoryID 
ORDER BY C.CategoryName, P.ProductID;
GO

--LEFT OUTER JOIN with CATEGORIES table on LEFT (first named) --
--SAME RESULT SET as PREVIOUS RIGHT OUTER JOIN --
SELECT C.CategoryName, P.ProductID, P.ProductName
FROM Production.Categories AS C
LEFT OUTER JOIN Production.Products AS P
on C.CategoryID = P.CategoryID 
ORDER BY C.CategoryName, P.ProductID;
GO

--FULL OUTER JOIN with PRODUCTS table on the LEFT (first named) --
SELECT C.CategoryName, P.ProductID, P.ProductName
FROM Production.Products AS P
FULL OUTER JOIN Production.Categories AS C
on P.CategoryID = C.CategoryID 
ORDER BY C.CategoryName, P.ProductID;
GO

--FULL OUTER JOIN with CATEGORIES table on LEFT (first named) --
--SAME RESULT SET as PREVIOUS RIGHT OUTER JOIN --
SELECT C.CategoryName, P.ProductID, P.ProductName
FROM Production.Categories AS C
FULL OUTER JOIN Production.Products AS P
on C.CategoryID = P.CategoryID 
ORDER BY C.CategoryName, P.ProductID;
GO

-- CROSS JOIN with PRODUCTS table on the LEFT (first named) --
-- NOTICE no ON clause since all combinations of data are returned --
SELECT C.CategoryName, P.ProductID, P.ProductName
FROM Production.Products AS P
CROSS JOIN Production.Categories AS C
--ON CLAUSE IS MISSING--
ORDER BY C.CategoryName, P.ProductID;
GO

-->>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
--Using SELF JOIN------------------------------------------------------------
USE [CertData]
GO

CREATE SCHEMA HumanResources;
GO
 --Create HumanResources.Employees table------------------------------------
CREATE TABLE [HumanResources].[Employees](
	[empid] [int] IDENTITY(1,1) NOT NULL,
	[name] [nvarchar](20) NOT NULL,
	[title] [nvarchar](30) NOT NULL,
	[mgrid] [int] NULL,
 CONSTRAINT [PK_Employees] PRIMARY KEY CLUSTERED 
(
	[empid] ASC
)WITH (PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON) ON [PRIMARY]
) ON [PRIMARY]

GO

ALTER TABLE [HumanResources].[Employees]  WITH CHECK ADD  CONSTRAINT [FK_Employees_Employees] FOREIGN KEY([mgrid])
REFERENCES [HumanResources].[Employees] ([empid])
GO

ALTER TABLE [HumanResources].[Employees] CHECK CONSTRAINT [FK_Employees_Employees]
GO

-----------------------------------------------------------------------------------
--------Insert Values into Employees table-----------------------------------------
USE CertData
GO

INSERT INTO HumanResources.Employees (name,title,mgrid)
     VALUES
           (N'Mickey', N'CEO',NULL),
		   (N'Minnie', N'VP Animation',1),
		   (N'Donald', N'Story Manager',2),
		   (N'Daisy', N'Story Writer',3),
		   (N'Grumpy', N'Story Research',2),
		   (N'Happy', N'Story Development',5),
		   (N'Dopey', N'Story Development',5);

GO

--------------------------------------------------------------------------------------
--Create Self-Join Query on HumanResources.Employees----------------------------------
USE CertData
GO

SELECT E.empid,
  E.name AS employee,
  M.name AS manager,
  E.mgrid as managerID 
FROM HumanResources.Employees AS E
  INNER JOIN HumanResources.Employees AS M
    ON E.mgrid = M.empid;
GO
