/*Lesson 5.15 Demo 5 - Use Statements that Load or Create Tables */

USE AdventureWorks2012
GO

IF OBJECT_ID('HumanResources.Contractors') IS NOT NULL DROP TABLE HumanResources.Contractors;
GO

CREATE TABLE HumanResources.Contractors
(
  entityID INT NOT NULL IDENTITY(1, 1)
    CONSTRAINT PK_Contractors_entityID PRIMARY KEY,
  loginID  nvarchar(256) NOT NULL,
  JobTitle nvarchar(50) NOT NULL,
  HireDate DATE NOT NULL
    CONSTRAINT DFT_Contractors_HireDate DEFAULT (CAST(SYSDATETIME() AS DATE))
);

--------------------------------------------------------------------
--------------------USE INSERT VALUES-------------------------------
--------------------------------------------------------------------
INSERT INTO HumanResources.Contractors (loginID, JobTitle, HireDate)
VALUES(N'adventure-works\marilyn', N'Courseware Developer', DEFAULT);
GO

--query the table--
SELECT *
FROM HumanResources.Contractors ;

---Delete the Inserted Value ---
DELETE FROM HumanResources.Contractors;
GO

---------------------------------------------------------------------
----USE INSERT SELECT -----------------------------------------------
---------------------------------------------------------------------

SET IDENTITY_INSERT HumanResources.Contractors  ON;

INSERT INTO HumanResources.Contractors (entityID, loginID, JobTitle, HireDate)
  SELECT BusinessEntityID, loginID, JobTitle, HireDate
  FROM HumanResources.Employee
  WHERE SalariedFlag = 0;

SET IDENTITY_INSERT HumanResources.Contractors OFF;

-- query the table
SELECT *
FROM HumanResources.Contractors;

---------------------------------------------------------------------
---------USE INSERT EXEC---------------------------------------------
---------------------------------------------------------------------

-- First Create Procedure which accepts input value --
-- and Returns result set 
IF OBJECT_ID('HumanResources.ContractorsStatus', 'P') IS NOT NULL
  DROP PROC HumanResources.ContractorsStatus;
GO

CREATE PROC HumanResources.ContractorsStatus
  @EmploymentStatus AS bit
AS
	SELECT BusinessEntityID, loginID, JobTitle, HireDate
	FROM HumanResources.Employee
	WHERE SalariedFlag = @EmploymentStatus;
GO

-- Run the stored procedure to ------------------------------
-- insert the results into the specified table --------------
SET IDENTITY_INSERT HumanResources.Contractors ON;

INSERT INTO HumanResources.Contractors(EntityID, loginID, JobTitle, HireDate)
  EXEC HumanResources.ContractorsStatus
    @EmploymentStatus = 1;

SET IDENTITY_INSERT HumanResources.Contractors OFF;

-- query the table
SELECT *
FROM HumanResources.Contractors;

---------------------------------------------------------------------
---- USE SELECT INTO ------------------------------------------------
---------------------------------------------------------------------

---Start with only the original table -------------------------------
IF OBJECT_ID('HumanResources.Contractors', 'U') IS NOT NULL 
DROP TABLE HumanResources.Contractors;

--Use SELECT INTO TO CREATE AND FILL new Contractors table ---------
--with only contractors emplyed by company -------------------------
SELECT BusinessEntityID, loginID, JobTitle, HireDate
INTO HumanResources.Contractors
FROM HumanResources.Employee
WHERE SalariedFlag = 0;
GO
-- query the table
SELECT *
FROM HumanResources.Contractors;

-- cleanup by deleting Contractors table ---------------
IF OBJECT_ID('HumanResources.Contractors', 'U') IS NOT NULL 
DROP TABLE HumanResources.Contractors;
GO
