/* Lesson 5.9 Use TOP(x) and OFFSET - FETCH to Filter Data */

USE AdventureWorks2012
GO

/* Using TOP(x) and OFFSET - FETCH to Filter Data */

--Using TOP --
-- Select the first 10 employees hired most recently.
SELECT TOP(10)LoginID, JobTitle, HireDate
FROM HumanResources.Employee
ORDER BY HireDate DESC, JobTitle, LoginID;
GO


 -- SELECT TOP 5 PERCENT (290 rows - 14.5 rows for 5 percent) --
 -- Query selects 15 rows --
SELECT TOP(5) PERCENT
LoginID, JobTitle, HireDate
FROM HumanResources.Employee
ORDER BY HireDate DESC, JobTitle;
GO

--Too many people hired on July 1, 2001 --
--16 rows in the query result set --
SELECT TOP(10) WITH TIES
LoginID, JobTitle, HireDate
FROM HumanResources.Employee
ORDER BY HireDate DESC, JobTitle;
GO

--Finally Deterministic --
-- 10 rows in query result set --
SELECT TOP(10) WITH TIES
LoginID, JobTitle, HireDate
FROM HumanResources.Employee
ORDER BY HireDate DESC, JobTitle, LoginID;
GO

--Using OFFSET - FETCH --
--Using OFFSET to start query result set at the 11th hiredate --
SELECT LoginID, JobTitle, HireDate
FROM HumanResources.Employee
ORDER BY HireDate DESC, JobTitle, LoginID 
OFFSET 10 ROWS;
GO

--Using OFFSET to start query result set at the 11th hiredate AND --
--FETCH NEXT 5 ROWS --
SELECT LoginID, JobTitle, HireDate
FROM HumanResources.Employee
ORDER BY HireDate DESC, JobTitle, LoginID 
OFFSET 10 ROWS FETCH NEXT 5 ROWS ONLY;
GO