/* Lesson 7.8 Demo 2 - Using Binary, String and Other Data Types*/

USE AdventureWorks2012
GO

--------------------------------------------------------------------
-->>>>>>FORMAT - new in SQL Server 2012<<<<<<-----------------------
--Using FORMAT to format a date to different locales----------------
--------------------------------------------------------------------
SELECT SalesOrderID, OrderDate, FORMAT(OrderDate, 'D', 'en-US' ) AS 'US English time format',FORMAT(OrderDate, 'D', 'de-de' ) AS 'German time format' 
	FROM Sales.SalesOrderDateTest;
GO

--------------------------------------------------------------------
-->>>>>>CONCAT - new in SQL Server 2012<<<<<------------------------
--Using CONCAT to concatenate two or more string values-------------
--------------------------------------------------------------------
USE AdventureWorks2012
GO

SELECT CONCAT( FirstName,' ', LastName) AS 'Full Name'
	FROM Person.Person;
GO

--------------------------------------------------------------------
--Using LEFT() to display first 4 characters in ----------------
-------------------------------------------------------------------

SELECT AddressID,City, LEFT(City,4) AS 'City 4 character ID'
	FROM Person.Address
	WHERE AddressID >= 300 AND AddressID <=310
GO

-----------------------------------------------------------------------
---------------store a SID and hexadecimal literal using varbinary----
----------------------------------------------------------------------
USE AdventureWorks2012;
GO
CREATE TABLE MyCustomerTable
(
    user_login   varbinary(85) DEFAULT SUSER_SID()
    ,data_value   varbinary(1)
);
GO

INSERT MyCustomerTable (data_value)
    VALUES (0x4F);
GO

SELECT * FROM MyCustomerTable
--------------------------------------------------------------------
-------------------------------------------------------------------
-->>>>>>>Query table with XML Data<<<<<<<--------------------------

SELECT *
FROM Production.ProductModel;  -- ProductModels have descriptions: 19, 23, 25, 28, 34, 35
GO
-------------------------------------------------------------
---Query xml data type for EXISTS-----------------------------
--------------------------------------------------------------
SELECT CatalogDescription.query('
declare namespace PD="http://schemas.microsoft.com/sqlserver/2004/07/adventure-works/ProductModelDescription";
<Product ProductModelID="{ /PD:ProductDescription[1]/@ProductModelID }" />
') as Result
FROM Production.ProductModel
where CatalogDescription.exist('
declare namespace PD="http://schemas.microsoft.com/sqlserver/2004/07/adventure-works/ProductModelDescription";
declare namespace wm="http://schemas.microsoft.com/sqlserver/2004/07/adventure-works/ProductModelWarrAndMain";
     /PD:ProductDescription/PD:Features/wm:Warranty ') = 1

--------------------------------------------------------------
---Query xml data type for QUERY-----------------------------
--------------------------------------------------------------
WITH XMLNAMESPACES (
   'http://schemas.microsoft.com/sqlserver/2004/07/adventure-works/ProductModelDescription' AS PD,
   'http://schemas.microsoft.com/sqlserver/2004/07/adventure-works/ProductModelWarrAndMain' AS wm)
SELECT CatalogDescription.query('
<Product ProductModelID="{ /PD:ProductDescription[1]/@ProductModelID }" />
') as Result
FROM Production.ProductModel
where CatalogDescription.exist('
     /PD:ProductDescription/PD:Features/wm:Warranty ') = 1

--------------------------------------------------------------
---Query xml data type for VALUE-----------------------------
--------------------------------------------------------------
SELECT CatalogDescription.value('           
    declare namespace PD="http://schemas.microsoft.com/sqlserver/2004/07/adventure-works/ProductModelDescription";           
       (/PD:ProductDescription/@ProductModelID)[1]', 'int') AS Result           
FROM Production.ProductModel           
WHERE CatalogDescription IS NOT NULL           
ORDER BY Result desc  

USE AdventureWorks2012
GO
---------------------------------------------------------------
--------Query Spatial Data for Nearest neighbor --------------
--------------------------------------------------------------
DECLARE @g geography = 'POINT(122.1239 47.6694)'; --longitude; latitude (Redmond, WA)
SELECT TOP(7) SpatialLocation.ToString(), City FROM Person.Address
WHERE SpatialLocation.STDistance(@g) IS NOT NULL
ORDER BY SpatialLocation.STDistance(@g);
GO

