/* Lesson 9 INLINE Code */

-->>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
/*Lesson 9.3 Query xml data using XQuery - Inline*/
DECLARE @x AS XML;
SET @x='
<CustomersOrders>
  <Customer CustomerID="29734" StoreID="852">
    <Orders SalesOrderID="43661" OrderDate="2005-07-01" SalesTotal="32,726.48" />
    <Orders SalesOrderID="44282" OrderDate="2005-10-01" SalesTotal="40,341.11" />
  </Customer>
</CustomersOrders>';
SELECT @x.query
('
for $custnode in //Customer
return
   <OrderTracking>
      { $custnode/@CustomerID }
      <NumberOfOrders>
		  { count($custnode/Orders) }
      </NumberOfOrders>
   </OrderTracking>
');
GO

-->>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
/* Lesson 9.6 Create XML Indexes - Inline */

---------------------------------------------------------
--Create Primary XML Index-------------------------------
---------------------------------------------------------
USE AdventureWorks2012;
gO
IF EXISTS (SELECT * FROM sys.indexes
            WHERE name = N'PXML_ProductModel_CatalogDescription')
    DROP INDEX PXML_ProductModel_CatalogDescription 
        ON Production.ProductModel;
GO
CREATE PRIMARY XML INDEX PXML_ProductModel_CatalogDescription
    ON Production.ProductModel (CatalogDescription);

---------------------------------------------------------
--Create Secondary XML Index-----------------------------
---------------------------------------------------------
USE AdventureWorks2012;
GO
IF EXISTS (SELECT name FROM sys.indexes
            WHERE name = N'IXML_ProductModel_CatalogDescription_Path')
    DROP INDEX IXML_ProductModel_CatalogDescription_Path
        ON Production.ProductModel;
GO
CREATE XML INDEX IXML_ProductModel_CatalogDescription_Path 
    ON Production.ProductModel (CatalogDescription)
    USING XML INDEX PXML_ProductModel_CatalogDescription FOR PATH ;
GO
